---
include:
  - local: .gitlab/ci/*.gitlab-ci.yml

stages:
  - lint
  - security
  - test
  - prebuild
  - build-images
  - build
  - validate-build
  - pre-deploy
  - deploy

variables:
  # Versions specified here are production versions
  # See also .tool-versions file for development versions
  # See also GO_VERSION declared in test:go job
  COREPACK_VERSION: "0.31.0"
  GO_VERSION: "1.23"
  GO_VERSION_PREVIOUS: "1.22"
  GOLANGCI_LINT_VERSION: "1.63.4"
  HUGO_VERSION: "0.142.0"
  LYCHEE_VERSION: "0.18.0"
  MARKDOWNLINT2_VERSION: "0.17.1"  # Version also set in package.json
  NODE_VERSION: "22"
  SHELLCHECK_VERSION: "0.10.0"
  VALE_VERSION: "3.9.3"
  YQ_VERSION: "4.44.1"

  # Linux distribution versions
  ALPINE_VERSION: "3.21"
  DEBIAN_VERSION: "bookworm"

  # Other versions
  ASDF_VERSION: "0.16.0"

workflow:
  name: '$DOCS_PROJECT_PIPELINE_TYPE'
  rules:
    # Prevent branch pipelines if an MR is open on the branch.
    - if: $CI_COMMIT_BRANCH && $CI_PIPELINE_SOURCE == "push" && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      variables:
        DOCS_PROJECT_PIPELINE_TYPE: "MR pipeline: branch $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
    - if: '$CI_PIPELINE_SOURCE == "trigger"'
      variables:
        DOCS_PROJECT_PIPELINE_TYPE: "Upstream review app pipeline"
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      variables:
        DOCS_PROJECT_PIPELINE_TYPE: "Default branch pipeline"
    - if: '$CI_COMMIT_BRANCH =~ /^\d{1,2}\.\d{1,2}$/'
      variables:
        DOCS_PROJECT_PIPELINE_TYPE: "Stable branch pipeline"
